-- This file is generated automagically by the JavaScript interface at
-- http://127.0.0.1/~yg/index.dev.html#!tool/config
-- Profile name : microYASEP
-- Tue, 21 Feb 2012 17:39:02 GMT

Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;

package yasep_definitions is
----------------------------------------------------------
-- user defined values :
  constant YASEP_SIZE : natural := 16;
  constant YASEP_MUL  : natural := 0;
  constant PIPELINED  : natural := 0;
  constant PC_LENGTH  : natural := 10;

----------------------------------------------------------
-- exported from the JavaScript definitions :

  subtype SLV2   is std_logic_vector( 1 downto 0);
  subtype SLV3   is std_logic_vector( 2 downto 0);
  subtype SLV4   is std_logic_vector( 3 downto 0);
  subtype SLV6   is std_logic_vector( 5 downto 0);
  subtype SLV8   is std_logic_vector( 7 downto 0);
  subtype SLV16  is std_logic_vector(15 downto 0);
  subtype SLV32  is std_logic_vector(31 downto 0);
  subtype SLVr64 is std_logic_vector(0 to 63);
  subtype SLVY   is std_logic_vector(YASEP_SIZE-1 downto 0);
  subtype SLVAI  is std_logic_vector(PC_LENGTH-1 downto 1);

-- To be used as "R_GROUP'range"
  subtype R_GROUP    is std_logic_vector( 4 downto  2);
  subtype R_FUNCTION is std_logic_vector( 7 downto  5);
  subtype R_OPCODE   is std_logic_vector( 7 downto  2);
  subtype R_SND      is std_logic_vector(11 downto  8);
  subtype R_SI4      is std_logic_vector(15 downto 12);
  subtype R_WR3      is std_logic_vector(27 downto 24);
  subtype R_COND     is std_logic_vector(31 downto 28);

  constant FORM_RR    : SLV2 := "00";
  constant FORM_RI4   : SLV2 := "10";
  constant FORM_RRI16 : SLV2 := "01";
  constant FORM_EXT   : SLV2 := "11";

  constant REG_PC  : SLV4 := "0000";
  constant REG_R1  : SLV4 := "0001";
  constant REG_R2  : SLV4 := "0010";
  constant REG_R3  : SLV4 := "0011";
  constant REG_R4  : SLV4 := "0100";
  constant REG_R5  : SLV4 := "0101";
  constant REG_D5  : SLV4 := "0110";
  constant REG_A5  : SLV4 := "0111";
  constant REG_D4  : SLV4 := "1000";
  constant REG_A4  : SLV4 := "1001";
  constant REG_D3  : SLV4 := "1010";
  constant REG_A3  : SLV4 := "1011";
  constant REG_D2  : SLV4 := "1100";
  constant REG_A2  : SLV4 := "1101";
  constant REG_D1  : SLV4 := "1110";
  constant REG_A1  : SLV4 := "1111";

  constant GROUP_CTL  : SLV3 :=    "000";
  constant Op_NOP     : SLV6 := "000000";  constant F_NOP    : SLV3 := "000";
  constant Op_GET     : SLV6 := "010000";  constant F_GET    : SLV3 := "010";
  constant Op_PUT     : SLV6 := "011000";  constant F_PUT    : SLV3 := "011";
  constant Op_CALL    : SLV6 := "110000";  constant F_CALL   : SLV3 := "110";
  constant Op_CALL2   : SLV6 := "111000";  constant F_CALL2  : SLV3 := "111";

  constant GROUP_SMT  : SLV3 :=    "001";

  constant GROUP_IE   : SLV3 :=    "010";
  constant Op_MOV     : SLV6 := "000010";  constant F_MOV    : SLV3 := "000";

  constant GROUP_SHL  : SLV3 :=    "011";

  constant GROUP_ROP2 : SLV3 :=    "100";
  constant Op_AND     : SLV6 := "000100";  constant F_AND    : SLV3 := "000";
  constant Op_ANDN    : SLV6 := "001100";  constant F_ANDN   : SLV3 := "001";
  constant Op_NAND    : SLV6 := "010100";  constant F_NAND   : SLV3 := "010";
  constant Op_OR      : SLV6 := "011100";  constant F_OR     : SLV3 := "011";
  constant Op_ORN     : SLV6 := "100100";  constant F_ORN    : SLV3 := "100";
  constant Op_NOR     : SLV6 := "101100";  constant F_NOR    : SLV3 := "101";
  constant Op_XOR     : SLV6 := "110100";  constant F_XOR    : SLV3 := "110";
  constant Op_XORN    : SLV6 := "111100";  constant F_XORN   : SLV3 := "111";

  constant GROUP_ASU  : SLV3 :=    "101";
  constant Op_ADD     : SLV6 := "000101";  constant F_ADD    : SLV3 := "000";
  constant Op_SUB     : SLV6 := "001101";  constant F_SUB    : SLV3 := "001";
  constant Op_CMPU    : SLV6 := "010101";  constant F_CMPU   : SLV3 := "010";
  constant Op_CMPS    : SLV6 := "011101";  constant F_CMPS   : SLV3 := "011";
  constant Op_UMIN    : SLV6 := "100101";  constant F_UMIN   : SLV3 := "100";
  constant Op_UMAX    : SLV6 := "101101";  constant F_UMAX   : SLV3 := "101";
  constant Op_SMIN    : SLV6 := "110101";  constant F_SMIN   : SLV3 := "110";
  constant Op_SMAX    : SLV6 := "111101";  constant F_SMAX   : SLV3 := "111";

  constant GROUP_MUL  : SLV3 :=    "110";

  constant GROUP_RSV  : SLV3 :=    "111";
  constant Op_INV     : SLV6 := "111111";  constant F_INV    : SLV3 := "111";


-- Flags :
  constant FlagValidInstruction : SLVr64 := "1010110000001100100011001000110000001100000011001000110010001101";
  constant FlagNoWriteBack      : SLVr64 := "1000000000000000000001001000010000000000000000000000000000000001";
  constant FlagNoCondition      : SLVr64 := "1000000000000000000000001000000000000000000000000000000000000001";
  constant FlagAbortWrite       : SLVr64 := "0000000000000000000000000000000000000100000001000000010000000100";
  constant FlagIgnoreSND        : SLVr64 := "1010000000000000100000000000000000000000000000001000000000000001";
  constant FlagIgnoreSI4        : SLVr64 := "1000000000000000000000000000000000000000000000000000000000000001";
  constant FlagIgnoreImm16      : SLVr64 := "1000000000000000000000000000000000000000000000000000000000000001";
  constant FlagChangeCarry      : SLVr64 := "0000010000000100000001000000010000000000000000000000000000000000";
end yasep_definitions;

package body yasep_definitions is
  -- empty
end yasep_definitions;
